precision mediump float;
uniform sampler2D u_Texture;

uniform int shaderMode;
uniform vec3 rotation;
uniform float scale,aspect;
  
varying vec2 v_TexCoordinate;

#define PI 3.141592653589793

mat3 getrot(vec3 r)
{
   float cx = cos(radians(r.x));
   float sx = sin(radians(r.x));
   float cy = cos(radians(r.y));
   float sy = sin(radians(r.y));
   float cz = cos(radians(r.z));
   float sz = sin(radians(r.z));

   float m1,m2,m3,m4,m5,m6,m7,m8,m9;

   m1=cy*cz;
   m2=cx*sz+sx*sy*cz;
   m3=sx*sz-cx*sy*cz;
   m4=-cy*sz;
   m5=cx*cz-sx*sy*sz;
   m6=sx*cz+cx*sy*sz;
   m7=sy;
   m8=-sx*cy;
   m9=cx*cy;

   return mat3(m1,m2,m3,m4,m5,m6,m7,m8,m9);
}

void main()                    		
{
	// us360 add
    if(shaderMode == 1){
		mat3 transform = getrot(rotation);
		vec2 rads = vec2(PI * 2., PI);
		vec2 pnt = (v_TexCoordinate - .5) * vec2(scale, scale * aspect);
		
		// Project to Sphere
		float x2y2 = pnt.x * pnt.x + pnt.y * pnt.y;
		vec3 sphere_pnt = vec3(2. * pnt, x2y2 - 1.) / (x2y2 + 1.);
		sphere_pnt *= transform;
		
		// Convert to Spherical Coordinates
		float r = length(sphere_pnt);
		float lon = atan(sphere_pnt.y, sphere_pnt.x);
		float lat = acos(sphere_pnt.z / r);
		
		vec2 coordinate = vec2(lon, lat) / rads;
		if(coordinate.x > 0.0){
		   gl_FragColor = texture2D(u_Texture, coordinate);
		}else{
		   vec2 coordinate2 = vec2(1.0+coordinate.x,coordinate.y);
		   gl_FragColor = texture2D(u_Texture, coordinate2);
		}
	}else{
		gl_FragColor = texture2D(u_Texture, v_TexCoordinate);
	}

	// original code
    //gl_FragColor =  texture2D(u_Texture, v_TexCoordinate);
}